# Class1InstanceApi

All URIs are relative to *https://api.chat-api.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**expiry**](Class1InstanceApi.md#expiry) | **POST** /expiry | Updates the QR code after its expired
[**getQRCode**](Class1InstanceApi.md#getQRCode) | **GET** /qr_code | Direct link to QR-code in the form of an image, not base64.
[**getSettings**](Class1InstanceApi.md#getSettings) | **GET** /settings | Get settings
[**getStatus**](Class1InstanceApi.md#getStatus) | **GET** /status | Get the account status and QR code for authorization.
[**logout**](Class1InstanceApi.md#logout) | **POST** /logout | Logout from WhatsApp Web to get new QR code.
[**reboot**](Class1InstanceApi.md#reboot) | **POST** /reboot | Reboot your whatsapp instance.
[**retry**](Class1InstanceApi.md#retry) | **POST** /retry | Repeat the manual synchronization attempt with the device
[**setSettings**](Class1InstanceApi.md#setSettings) | **POST** /settings | Set settings
[**takeover**](Class1InstanceApi.md#takeover) | **POST** /takeover | Returns the active session if the device has connected another instance of Web WhatsApp



## expiry

> InlineResponse2002 expiry()

Updates the QR code after its expired

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    InlineResponse2002 result = apiInstance.expiry();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#expiry");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**InlineResponse2002**](InlineResponse2002.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## getQRCode

> File getQRCode()

Direct link to QR-code in the form of an image, not base64.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    File result = apiInstance.getQRCode();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#getQRCode");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**File**](File.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: image/png


## getSettings

> Settings getSettings()

Get settings

**webhookUrl** - Http or https URL for receiving notifications. For testing, we recommend using [our RequestBin](http://bin.chat-api.com).  **ackNotificationsOn** - Turn on/off ack (message delivered and message viewed) notifications in webhooks. GET method works for the same address.  **chatUpdateOn** - Turn on/off chat update notifications in webhooks. GET method works for the same address.  **videoUploadOn** - Turn on/off receiving video messages.  **proxy** - Socks5 IP address and port proxy for instance.  **guaranteedHooks** - Guarantee webhook delivery. Each webhook will make 20 attempts to send until it receives 200 status from the server.  **ignoreOldMessages** - Do not send webhooks with old messages during authorization.  **processArchive** - Process messages from archived chats.  **instanceStatuses** - Turn on/off collecting instance status changing history.  **webhookStatuses** - Turn on/off collecting messages webhooks statuses.  **statusNotificationsOn** - Turn on/off instance changind status notifications in webhooks.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    Settings result = apiInstance.getSettings();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#getSettings");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**Settings**](Settings.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## getStatus

> InstanceStatus getStatus(full, noWakeup)

Get the account status and QR code for authorization.

Reauthorization is necessary only in case of changing the device or manually pressing \&quot;Logout on all devices\&quot; on the phone. Keep the WhastsApp application open during authorization.  Instance statuses:  **authenticated** -  Authorization passed successfully  **init** -  Initial status   **loading** -  The system is still loading, try again in 1 minute   **got qr code** -  There is a QR code and you need to take a picture of it in the Whatsapp application by going to Menu -&gt; WhatsApp Web -&gt; Add. QR code is valid for one minute.   [Example showing base64 images on a page.](https://stackoverflow.com/questions/31526085/how-to-encode-an-image-into-an-html-file)  Manually easier to get [QR-code as an image](/#getQRCode)    When you request the status of the instance in standby mode (status **\&quot;init\&quot;**), it will automatically turn on. To avoid this behavior, use the **no_wakeup** parameter

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
Boolean full = true; // Boolean | Get full information on the current status
Boolean noWakeup = true; // Boolean | Ignore autowakeup
try {
    InstanceStatus result = apiInstance.getStatus(full, noWakeup);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#getStatus");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **full** | **Boolean**| Get full information on the current status | [optional] [default to false]
 **noWakeup** | **Boolean**| Ignore autowakeup | [optional] [default to false]

### Return type

[**InstanceStatus**](InstanceStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## logout

> InlineResponse200 logout()

Logout from WhatsApp Web to get new QR code.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    InlineResponse200 result = apiInstance.logout();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#logout");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reboot

> InlineResponse2004 reboot()

Reboot your whatsapp instance.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    InlineResponse2004 result = apiInstance.reboot();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#reboot");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**InlineResponse2004**](InlineResponse2004.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## retry

> InlineResponse2003 retry()

Repeat the manual synchronization attempt with the device

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    InlineResponse2003 result = apiInstance.retry();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#retry");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## setSettings

> InlineResponse2005 setSettings(settings)

Set settings

**webhookUrl** - Http or https URL for receiving notifications. For testing, we recommend using [our RequestBin](http://bin.chat-api.com).  **ackNotificationsOn** - Turn on/off ack (message delivered and message viewed) notifications in webhooks. GET method works for the same address.  **chatUpdateOn** - Turn on/off chat update notifications in webhooks. GET method works for the same address.  **videoUploadOn** - Turn on/off receiving video messages.  **proxy** - Socks5 IP address and port proxy for instance.  **guaranteedHooks** - Guarantee webhook delivery. Each webhook will make 20 attempts to send until it receives 200 status from the server.  **ignoreOldMessages** - Do not send webhooks with old messages during authorization.  **processArchive** - Process messages from archived chats.  **instanceStatuses** - Turn on/off collecting instance status changing history.  **webhookStatuses** - Turn on/off collecting messages webhooks statuses.  **statusNotificationsOn** - Turn on/off instance changind status notifications in webhooks.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
Settings settings = new Settings(); // Settings | 
try {
    InlineResponse2005 result = apiInstance.setSettings(settings);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#setSettings");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **settings** | [**Settings**](Settings.md)|  |

### Return type

[**InlineResponse2005**](InlineResponse2005.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/json, application/x-www-form-urlencoded
- **Accept**: application/json


## takeover

> InlineResponse2001 takeover()

Returns the active session if the device has connected another instance of Web WhatsApp

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class1InstanceApi;

Class1InstanceApi apiInstance = new Class1InstanceApi();
try {
    InlineResponse2001 result = apiInstance.takeover();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class1InstanceApi#takeover");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

