# Class2MessagesApi

All URIs are relative to *https://api.chat-api.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**forwardMessage**](Class2MessagesApi.md#forwardMessage) | **POST** /forwardMessage | Forwarding messages to a new or existing chat.
[**getMessages**](Class2MessagesApi.md#getMessages) | **GET** /messages | Get a list of messages.
[**sendContact**](Class2MessagesApi.md#sendContact) | **POST** /sendContact | Sending a contact or contact list to a new or existing chat.
[**sendFile**](Class2MessagesApi.md#sendFile) | **POST** /sendFile | Send a file to a new or existing chat.
[**sendLink**](Class2MessagesApi.md#sendLink) | **POST** /sendLink | Send text with link and link&#39;s preview to a new or existing chat.
[**sendLocation**](Class2MessagesApi.md#sendLocation) | **POST** /sendLocation | Sending a location to a new or existing chat.
[**sendMessage**](Class2MessagesApi.md#sendMessage) | **POST** /sendMessage | Send a message to a new or existing chat.
[**sendPTT**](Class2MessagesApi.md#sendPTT) | **POST** /sendPTT | Send a ptt-audio to a new or existing chat.
[**sendVCard**](Class2MessagesApi.md#sendVCard) | **POST** /sendVCard | Sending a vcard to a new or existing chat.



## forwardMessage

> SendMessageStatus forwardMessage(forwardMessageRequest)

Forwarding messages to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
ForwardMessageRequest forwardMessageRequest = new ForwardMessageRequest(); // ForwardMessageRequest | 
try {
    SendMessageStatus result = apiInstance.forwardMessage(forwardMessageRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#forwardMessage");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **forwardMessageRequest** | [**ForwardMessageRequest**](ForwardMessageRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## getMessages

> Messages getMessages(lastMessageNumber, last, chatId, limit, minTime, maxTime)

Get a list of messages.

To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
Integer lastMessageNumber = 0; // Integer | The lastMessageNumber parameter from the last response
Boolean last = true; // Boolean | Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored.
String chatId = 17633123456@c.us; // String | Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group.
Integer limit = 100; // Integer | Sets length of the message list. Default 100. With value 0 returns all messages.
Integer minTime = 946684800; // Integer | Filter messages received after specified time. Example: 946684800.
Integer maxTime = 946684800; // Integer | Filter messages received before specified time. Example: 946684800.
try {
    Messages result = apiInstance.getMessages(lastMessageNumber, last, chatId, limit, minTime, maxTime);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#getMessages");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lastMessageNumber** | **Integer**| The lastMessageNumber parameter from the last response | [optional] [default to null]
 **last** | **Boolean**| Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. | [optional] [default to false]
 **chatId** | **String**| Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. | [optional] [default to null]
 **limit** | **Integer**| Sets length of the message list. Default 100. With value 0 returns all messages. | [optional] [default to null]
 **minTime** | **Integer**| Filter messages received after specified time. Example: 946684800. | [optional] [default to null]
 **maxTime** | **Integer**| Filter messages received before specified time. Example: 946684800. | [optional] [default to null]

### Return type

[**Messages**](Messages.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## sendContact

> SendMessageStatus sendContact(sendContactRequest)

Sending a contact or contact list to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendContactRequest sendContactRequest = new SendContactRequest(); // SendContactRequest | 
try {
    SendMessageStatus result = apiInstance.sendContact(sendContactRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendContact");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendContactRequest** | [**SendContactRequest**](SendContactRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## sendFile

> SendMessageStatus sendFile(sendFileRequest)

Send a file to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendFileRequest sendFileRequest = new SendFileRequest(); // SendFileRequest | 
try {
    SendMessageStatus result = apiInstance.sendFile(sendFileRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendFile");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendFileRequest** | [**SendFileRequest**](SendFileRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## sendLink

> SendMessageStatus sendLink(sendLinkRequest)

Send text with link and link&#39;s preview to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendLinkRequest sendLinkRequest = new SendLinkRequest(); // SendLinkRequest | 
try {
    SendMessageStatus result = apiInstance.sendLink(sendLinkRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendLink");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendLinkRequest** | [**SendLinkRequest**](SendLinkRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## sendLocation

> SendMessageStatus sendLocation(sendLocationRequest)

Sending a location to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendLocationRequest sendLocationRequest = new SendLocationRequest(); // SendLocationRequest | 
try {
    SendMessageStatus result = apiInstance.sendLocation(sendLocationRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendLocation");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendLocationRequest** | [**SendLocationRequest**](SendLocationRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## sendMessage

> SendMessageStatus sendMessage(sendMessageRequest)

Send a message to a new or existing chat.

The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendMessageRequest sendMessageRequest = new SendMessageRequest(); // SendMessageRequest | 
try {
    SendMessageStatus result = apiInstance.sendMessage(sendMessageRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendMessage");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendMessageRequest** | [**SendMessageRequest**](SendMessageRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## sendPTT

> SendMessageStatus sendPTT(sendPTTRequest)

Send a ptt-audio to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendPTTRequest sendPTTRequest = new SendPTTRequest(); // SendPTTRequest | 
try {
    SendMessageStatus result = apiInstance.sendPTT(sendPTTRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendPTT");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendPTTRequest** | [**SendPTTRequest**](SendPTTRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json


## sendVCard

> SendMessageStatus sendVCard(sendVCardRequest)

Sending a vcard to a new or existing chat.

Only one of two parameters is needed to determine the destination - chatId or phone.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class2MessagesApi;

Class2MessagesApi apiInstance = new Class2MessagesApi();
SendVCardRequest sendVCardRequest = new SendVCardRequest(); // SendVCardRequest | 
try {
    SendMessageStatus result = apiInstance.sendVCard(sendVCardRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class2MessagesApi#sendVCard");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sendVCardRequest** | [**SendVCardRequest**](SendVCardRequest.md)|  |

### Return type

[**SendMessageStatus**](SendMessageStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/x-www-form-urlencoded, application/json
- **Accept**: application/json

