# Class5QueuesApi

All URIs are relative to *https://api.chat-api.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**clearActionsQueue**](Class5QueuesApi.md#clearActionsQueue) | **POST** /clearActionsQueue | Clear outbound actions queue.
[**clearMessagesQueue**](Class5QueuesApi.md#clearMessagesQueue) | **POST** /clearMessagesQueue | Clear outbound messages queue.
[**showActionsQueue**](Class5QueuesApi.md#showActionsQueue) | **GET** /showActionsQueue | Get outbound messages queue.
[**showMessagesQueue**](Class5QueuesApi.md#showMessagesQueue) | **GET** /showMessagesQueue | Get outbound messages queue.



## clearActionsQueue

> ClearActionsQueueStatus clearActionsQueue()

Clear outbound actions queue.

This method is needed when you accidentally sent thousands of actions in a row.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class5QueuesApi;

Class5QueuesApi apiInstance = new Class5QueuesApi();
try {
    ClearActionsQueueStatus result = apiInstance.clearActionsQueue();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class5QueuesApi#clearActionsQueue");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**ClearActionsQueueStatus**](ClearActionsQueueStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## clearMessagesQueue

> ClearMessagesQueueStatus clearMessagesQueue()

Clear outbound messages queue.

This method is needed when you accidentally sent thousands of messages in a row.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class5QueuesApi;

Class5QueuesApi apiInstance = new Class5QueuesApi();
try {
    ClearMessagesQueueStatus result = apiInstance.clearMessagesQueue();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class5QueuesApi#clearMessagesQueue");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**ClearMessagesQueueStatus**](ClearMessagesQueueStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## showActionsQueue

> OutboundActions showActionsQueue()

Get outbound messages queue.

When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class5QueuesApi;

Class5QueuesApi apiInstance = new Class5QueuesApi();
try {
    OutboundActions result = apiInstance.showActionsQueue();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class5QueuesApi#showActionsQueue");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**OutboundActions**](OutboundActions.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## showMessagesQueue

> OutboundMessages showMessagesQueue()

Get outbound messages queue.

When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class5QueuesApi;

Class5QueuesApi apiInstance = new Class5QueuesApi();
try {
    OutboundMessages result = apiInstance.showMessagesQueue();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class5QueuesApi#showMessagesQueue");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**OutboundMessages**](OutboundMessages.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

