# Class6BanApi

All URIs are relative to *https://api.chat-api.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**banTest**](Class6BanApi.md#banTest) | **POST** /banTest | Test ban settings
[**getBanSettings**](Class6BanApi.md#getBanSettings) | **GET** /banSettings | Get settings
[**setBanSettings**](Class6BanApi.md#setBanSettings) | **POST** /banSettings | Set settings



## banTest

> BanTestStatus banTest(banTestAction)

Test ban settings

Send the phone number to find out if the instance is banning it

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class6BanApi;

Class6BanApi apiInstance = new Class6BanApi();
BanTestAction banTestAction = new BanTestAction(); // BanTestAction | 
try {
    BanTestStatus result = apiInstance.banTest(banTestAction);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class6BanApi#banTest");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **banTestAction** | [**BanTestAction**](BanTestAction.md)|  |

### Return type

[**BanTestStatus**](BanTestStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/json, application/x-www-form-urlencoded
- **Accept**: application/json


## getBanSettings

> BanSettings getBanSettings()

Get settings

**banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class6BanApi;

Class6BanApi apiInstance = new Class6BanApi();
try {
    BanSettings result = apiInstance.getBanSettings();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class6BanApi#getBanSettings");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BanSettings**](BanSettings.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## setBanSettings

> BanSettings setBanSettings(banSettings)

Set settings

**banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class6BanApi;

Class6BanApi apiInstance = new Class6BanApi();
BanSettings banSettings = new BanSettings(); // BanSettings | 
try {
    BanSettings result = apiInstance.setBanSettings(banSettings);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class6BanApi#setBanSettings");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **banSettings** | [**BanSettings**](BanSettings.md)|  |

### Return type

[**BanSettings**](BanSettings.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: application/json, application/x-www-form-urlencoded
- **Accept**: application/json

