# Class7TestingApi

All URIs are relative to *https://api.chat-api.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**instanceStatuses**](Class7TestingApi.md#instanceStatuses) | **GET** /instanceStatuses | Returns instance status changes history.
[**webhookStatuses**](Class7TestingApi.md#webhookStatuses) | **GET** /webhookStatus | Returns webhook status for message.



## instanceStatuses

> Statuses instanceStatuses(minTime, maxTime)

Returns instance status changes history.

Requires enable \&quot;instanceStatuses\&quot; option for collecting data.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class7TestingApi;

Class7TestingApi apiInstance = new Class7TestingApi();
Integer minTime = 946684800; // Integer | Filter statuses received after specified date. Example: 946684800.
Integer maxTime = 946684800; // Integer | Filter statuses received before specified date. Example: 946684800.
try {
    Statuses result = apiInstance.instanceStatuses(minTime, maxTime);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class7TestingApi#instanceStatuses");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **minTime** | **Integer**| Filter statuses received after specified date. Example: 946684800. | [optional] [default to null]
 **maxTime** | **Integer**| Filter statuses received before specified date. Example: 946684800. | [optional] [default to null]

### Return type

[**Statuses**](Statuses.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## webhookStatuses

> WebhookStatus webhookStatuses(msgId)

Returns webhook status for message.

Requires enable \&quot;webhookStatuses\&quot; option for collecting data.

### Example

```java
// Import classes:
//import org.openapitools.client.api.Class7TestingApi;

Class7TestingApi apiInstance = new Class7TestingApi();
String msgId = false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F; // String | Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.
try {
    WebhookStatus result = apiInstance.webhookStatuses(msgId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Class7TestingApi#webhookStatuses");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **msgId** | **String**| Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F. | [default to null]

### Return type

[**WebhookStatus**](WebhookStatus.md)

### Authorization

[instanceId](../README.md#instanceId), [token](../README.md#token)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

