/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonParseException;
import com.google.gson.reflect.TypeToken;
import java.lang.reflect.Type;
import java.util.List;
import java.util.Date;
import org.openapitools.client.model.*;

public class JsonUtil {
  public static GsonBuilder gsonBuilder;

  static {
    gsonBuilder = new GsonBuilder();
    gsonBuilder.serializeNulls();
    gsonBuilder.setDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
    gsonBuilder.registerTypeAdapter(Date.class, new JsonDeserializer<Date>() {
      public Date deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
        return new Date(json.getAsJsonPrimitive().getAsLong());
      }
    });
  }

  public static Gson getGson() {
    return gsonBuilder.create();
  }

  public static String serialize(Object obj){
    return getGson().toJson(obj);
  }

  public static <T> T deserializeToList(String jsonString, Class cls){
    return getGson().fromJson(jsonString, getListTypeForDeserialization(cls));
  }

  public static <T> T deserializeToObject(String jsonString, Class cls){
    return getGson().fromJson(jsonString, getTypeForDeserialization(cls));
  }

  public static Type getListTypeForDeserialization(Class cls) {
    String className = cls.getSimpleName();
    
    if ("Ack".equalsIgnoreCase(className)) {
      return new TypeToken<List<Ack>>(){}.getType();
    }
    
    if ("BanSettings".equalsIgnoreCase(className)) {
      return new TypeToken<List<BanSettings>>(){}.getType();
    }
    
    if ("BanTestAction".equalsIgnoreCase(className)) {
      return new TypeToken<List<BanTestAction>>(){}.getType();
    }
    
    if ("BanTestStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<BanTestStatus>>(){}.getType();
    }
    
    if ("Chat".equalsIgnoreCase(className)) {
      return new TypeToken<List<Chat>>(){}.getType();
    }
    
    if ("ChatIdProp".equalsIgnoreCase(className)) {
      return new TypeToken<List<ChatIdProp>>(){}.getType();
    }
    
    if ("ChatUpdate".equalsIgnoreCase(className)) {
      return new TypeToken<List<ChatUpdate>>(){}.getType();
    }
    
    if ("Chats".equalsIgnoreCase(className)) {
      return new TypeToken<List<Chats>>(){}.getType();
    }
    
    if ("ClearActionsQueueStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<ClearActionsQueueStatus>>(){}.getType();
    }
    
    if ("ClearMessagesQueueStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<ClearMessagesQueueStatus>>(){}.getType();
    }
    
    if ("CreateGroupAction".equalsIgnoreCase(className)) {
      return new TypeToken<List<CreateGroupAction>>(){}.getType();
    }
    
    if ("CreateGroupStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<CreateGroupStatus>>(){}.getType();
    }
    
    if ("ForwardMessageRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<ForwardMessageRequest>>(){}.getType();
    }
    
    if ("GroupParticipantAction".equalsIgnoreCase(className)) {
      return new TypeToken<List<GroupParticipantAction>>(){}.getType();
    }
    
    if ("GroupParticipantStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<GroupParticipantStatus>>(){}.getType();
    }
    
    if ("InlineResponse200".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse200>>(){}.getType();
    }
    
    if ("InlineResponse2001".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse2001>>(){}.getType();
    }
    
    if ("InlineResponse2002".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse2002>>(){}.getType();
    }
    
    if ("InlineResponse2003".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse2003>>(){}.getType();
    }
    
    if ("InlineResponse2004".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse2004>>(){}.getType();
    }
    
    if ("InlineResponse2005".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse2005>>(){}.getType();
    }
    
    if ("InlineResponse2005Update".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse2005Update>>(){}.getType();
    }
    
    if ("InlineResponse401".equalsIgnoreCase(className)) {
      return new TypeToken<List<InlineResponse401>>(){}.getType();
    }
    
    if ("InstanceStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<InstanceStatus>>(){}.getType();
    }
    
    if ("InstanceStatusAction".equalsIgnoreCase(className)) {
      return new TypeToken<List<InstanceStatusAction>>(){}.getType();
    }
    
    if ("InstanceStatusLink".equalsIgnoreCase(className)) {
      return new TypeToken<List<InstanceStatusLink>>(){}.getType();
    }
    
    if ("InstanceStatusStatusData".equalsIgnoreCase(className)) {
      return new TypeToken<List<InstanceStatusStatusData>>(){}.getType();
    }
    
    if ("InstanceStatusStatusDataActions".equalsIgnoreCase(className)) {
      return new TypeToken<List<InstanceStatusStatusDataActions>>(){}.getType();
    }
    
    if ("Message".equalsIgnoreCase(className)) {
      return new TypeToken<List<Message>>(){}.getType();
    }
    
    if ("Messages".equalsIgnoreCase(className)) {
      return new TypeToken<List<Messages>>(){}.getType();
    }
    
    if ("OutboundAction".equalsIgnoreCase(className)) {
      return new TypeToken<List<OutboundAction>>(){}.getType();
    }
    
    if ("OutboundActions".equalsIgnoreCase(className)) {
      return new TypeToken<List<OutboundActions>>(){}.getType();
    }
    
    if ("OutboundMessage".equalsIgnoreCase(className)) {
      return new TypeToken<List<OutboundMessage>>(){}.getType();
    }
    
    if ("OutboundMessages".equalsIgnoreCase(className)) {
      return new TypeToken<List<OutboundMessages>>(){}.getType();
    }
    
    if ("PhoneProp".equalsIgnoreCase(className)) {
      return new TypeToken<List<PhoneProp>>(){}.getType();
    }
    
    if ("ReadChatAction".equalsIgnoreCase(className)) {
      return new TypeToken<List<ReadChatAction>>(){}.getType();
    }
    
    if ("ReadChatStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<ReadChatStatus>>(){}.getType();
    }
    
    if ("SendContactRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendContactRequest>>(){}.getType();
    }
    
    if ("SendFileRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendFileRequest>>(){}.getType();
    }
    
    if ("SendLinkRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendLinkRequest>>(){}.getType();
    }
    
    if ("SendLocationRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendLocationRequest>>(){}.getType();
    }
    
    if ("SendMessageRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendMessageRequest>>(){}.getType();
    }
    
    if ("SendMessageStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendMessageStatus>>(){}.getType();
    }
    
    if ("SendPTTRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendPTTRequest>>(){}.getType();
    }
    
    if ("SendVCardRequest".equalsIgnoreCase(className)) {
      return new TypeToken<List<SendVCardRequest>>(){}.getType();
    }
    
    if ("SetWebhookStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<SetWebhookStatus>>(){}.getType();
    }
    
    if ("Settings".equalsIgnoreCase(className)) {
      return new TypeToken<List<Settings>>(){}.getType();
    }
    
    if ("Status".equalsIgnoreCase(className)) {
      return new TypeToken<List<Status>>(){}.getType();
    }
    
    if ("Statuses".equalsIgnoreCase(className)) {
      return new TypeToken<List<Statuses>>(){}.getType();
    }
    
    if ("WebhookStatus".equalsIgnoreCase(className)) {
      return new TypeToken<List<WebhookStatus>>(){}.getType();
    }
    
    if ("WebhookUrl".equalsIgnoreCase(className)) {
      return new TypeToken<List<WebhookUrl>>(){}.getType();
    }
    
    return new TypeToken<List<Object>>(){}.getType();
  }

  public static Type getTypeForDeserialization(Class cls) {
    String className = cls.getSimpleName();
    
    if ("Ack".equalsIgnoreCase(className)) {
      return new TypeToken<Ack>(){}.getType();
    }
    
    if ("BanSettings".equalsIgnoreCase(className)) {
      return new TypeToken<BanSettings>(){}.getType();
    }
    
    if ("BanTestAction".equalsIgnoreCase(className)) {
      return new TypeToken<BanTestAction>(){}.getType();
    }
    
    if ("BanTestStatus".equalsIgnoreCase(className)) {
      return new TypeToken<BanTestStatus>(){}.getType();
    }
    
    if ("Chat".equalsIgnoreCase(className)) {
      return new TypeToken<Chat>(){}.getType();
    }
    
    if ("ChatIdProp".equalsIgnoreCase(className)) {
      return new TypeToken<ChatIdProp>(){}.getType();
    }
    
    if ("ChatUpdate".equalsIgnoreCase(className)) {
      return new TypeToken<ChatUpdate>(){}.getType();
    }
    
    if ("Chats".equalsIgnoreCase(className)) {
      return new TypeToken<Chats>(){}.getType();
    }
    
    if ("ClearActionsQueueStatus".equalsIgnoreCase(className)) {
      return new TypeToken<ClearActionsQueueStatus>(){}.getType();
    }
    
    if ("ClearMessagesQueueStatus".equalsIgnoreCase(className)) {
      return new TypeToken<ClearMessagesQueueStatus>(){}.getType();
    }
    
    if ("CreateGroupAction".equalsIgnoreCase(className)) {
      return new TypeToken<CreateGroupAction>(){}.getType();
    }
    
    if ("CreateGroupStatus".equalsIgnoreCase(className)) {
      return new TypeToken<CreateGroupStatus>(){}.getType();
    }
    
    if ("ForwardMessageRequest".equalsIgnoreCase(className)) {
      return new TypeToken<ForwardMessageRequest>(){}.getType();
    }
    
    if ("GroupParticipantAction".equalsIgnoreCase(className)) {
      return new TypeToken<GroupParticipantAction>(){}.getType();
    }
    
    if ("GroupParticipantStatus".equalsIgnoreCase(className)) {
      return new TypeToken<GroupParticipantStatus>(){}.getType();
    }
    
    if ("InlineResponse200".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse200>(){}.getType();
    }
    
    if ("InlineResponse2001".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse2001>(){}.getType();
    }
    
    if ("InlineResponse2002".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse2002>(){}.getType();
    }
    
    if ("InlineResponse2003".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse2003>(){}.getType();
    }
    
    if ("InlineResponse2004".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse2004>(){}.getType();
    }
    
    if ("InlineResponse2005".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse2005>(){}.getType();
    }
    
    if ("InlineResponse2005Update".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse2005Update>(){}.getType();
    }
    
    if ("InlineResponse401".equalsIgnoreCase(className)) {
      return new TypeToken<InlineResponse401>(){}.getType();
    }
    
    if ("InstanceStatus".equalsIgnoreCase(className)) {
      return new TypeToken<InstanceStatus>(){}.getType();
    }
    
    if ("InstanceStatusAction".equalsIgnoreCase(className)) {
      return new TypeToken<InstanceStatusAction>(){}.getType();
    }
    
    if ("InstanceStatusLink".equalsIgnoreCase(className)) {
      return new TypeToken<InstanceStatusLink>(){}.getType();
    }
    
    if ("InstanceStatusStatusData".equalsIgnoreCase(className)) {
      return new TypeToken<InstanceStatusStatusData>(){}.getType();
    }
    
    if ("InstanceStatusStatusDataActions".equalsIgnoreCase(className)) {
      return new TypeToken<InstanceStatusStatusDataActions>(){}.getType();
    }
    
    if ("Message".equalsIgnoreCase(className)) {
      return new TypeToken<Message>(){}.getType();
    }
    
    if ("Messages".equalsIgnoreCase(className)) {
      return new TypeToken<Messages>(){}.getType();
    }
    
    if ("OutboundAction".equalsIgnoreCase(className)) {
      return new TypeToken<OutboundAction>(){}.getType();
    }
    
    if ("OutboundActions".equalsIgnoreCase(className)) {
      return new TypeToken<OutboundActions>(){}.getType();
    }
    
    if ("OutboundMessage".equalsIgnoreCase(className)) {
      return new TypeToken<OutboundMessage>(){}.getType();
    }
    
    if ("OutboundMessages".equalsIgnoreCase(className)) {
      return new TypeToken<OutboundMessages>(){}.getType();
    }
    
    if ("PhoneProp".equalsIgnoreCase(className)) {
      return new TypeToken<PhoneProp>(){}.getType();
    }
    
    if ("ReadChatAction".equalsIgnoreCase(className)) {
      return new TypeToken<ReadChatAction>(){}.getType();
    }
    
    if ("ReadChatStatus".equalsIgnoreCase(className)) {
      return new TypeToken<ReadChatStatus>(){}.getType();
    }
    
    if ("SendContactRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendContactRequest>(){}.getType();
    }
    
    if ("SendFileRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendFileRequest>(){}.getType();
    }
    
    if ("SendLinkRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendLinkRequest>(){}.getType();
    }
    
    if ("SendLocationRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendLocationRequest>(){}.getType();
    }
    
    if ("SendMessageRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendMessageRequest>(){}.getType();
    }
    
    if ("SendMessageStatus".equalsIgnoreCase(className)) {
      return new TypeToken<SendMessageStatus>(){}.getType();
    }
    
    if ("SendPTTRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendPTTRequest>(){}.getType();
    }
    
    if ("SendVCardRequest".equalsIgnoreCase(className)) {
      return new TypeToken<SendVCardRequest>(){}.getType();
    }
    
    if ("SetWebhookStatus".equalsIgnoreCase(className)) {
      return new TypeToken<SetWebhookStatus>(){}.getType();
    }
    
    if ("Settings".equalsIgnoreCase(className)) {
      return new TypeToken<Settings>(){}.getType();
    }
    
    if ("Status".equalsIgnoreCase(className)) {
      return new TypeToken<Status>(){}.getType();
    }
    
    if ("Statuses".equalsIgnoreCase(className)) {
      return new TypeToken<Statuses>(){}.getType();
    }
    
    if ("WebhookStatus".equalsIgnoreCase(className)) {
      return new TypeToken<WebhookStatus>(){}.getType();
    }
    
    if ("WebhookUrl".equalsIgnoreCase(className)) {
      return new TypeToken<WebhookUrl>(){}.getType();
    }
    
    return new TypeToken<Object>(){}.getType();
  }

};
