/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.api;

import org.openapitools.client.ApiInvoker;
import org.openapitools.client.ApiException;
import org.openapitools.client.Pair;

import org.openapitools.client.model.*;

import java.util.*;

import com.android.volley.Response;
import com.android.volley.VolleyError;

import org.openapitools.client.model.ForwardMessageRequest;
import org.openapitools.client.model.Messages;
import org.openapitools.client.model.SendContactRequest;
import org.openapitools.client.model.SendFileRequest;
import org.openapitools.client.model.SendLinkRequest;
import org.openapitools.client.model.SendLocationRequest;
import org.openapitools.client.model.SendMessageRequest;
import org.openapitools.client.model.SendMessageStatus;
import org.openapitools.client.model.SendPTTRequest;
import org.openapitools.client.model.SendVCardRequest;

import org.apache.http.HttpEntity;
import org.apache.http.entity.mime.MultipartEntityBuilder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;

public class Class2MessagesApi {
  String basePath = "https://api.chat-api.com";
  ApiInvoker apiInvoker = ApiInvoker.getInstance();

  public void addHeader(String key, String value) {
    getInvoker().addDefaultHeader(key, value);
  }

  public ApiInvoker getInvoker() {
    return apiInvoker;
  }

  public void setBasePath(String basePath) {
    this.basePath = basePath;
  }

  public String getBasePath() {
    return basePath;
  }

  /**
  * Forwarding messages to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param forwardMessageRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus forwardMessage (ForwardMessageRequest forwardMessageRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = forwardMessageRequest;
    // verify the required parameter 'forwardMessageRequest' is set
    if (forwardMessageRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'forwardMessageRequest' when calling forwardMessage",
        new ApiException(400, "Missing the required parameter 'forwardMessageRequest' when calling forwardMessage"));
    }

    // create path and map variables
    String path = "/forwardMessage";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Forwarding messages to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param forwardMessageRequest 
  */
  public void forwardMessage (ForwardMessageRequest forwardMessageRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = forwardMessageRequest;

    // verify the required parameter 'forwardMessageRequest' is set
    if (forwardMessageRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'forwardMessageRequest' when calling forwardMessage",
        new ApiException(400, "Missing the required parameter 'forwardMessageRequest' when calling forwardMessage"));
    }

    // create path and map variables
    String path = "/forwardMessage".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Get a list of messages.
  * To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
   * @param lastMessageNumber The lastMessageNumber parameter from the last response
   * @param last Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored.
   * @param chatId Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group.
   * @param limit Sets length of the message list. Default 100. With value 0 returns all messages.
   * @param minTime Filter messages received after specified time. Example: 946684800.
   * @param maxTime Filter messages received before specified time. Example: 946684800.
   * @return Messages
  */
  public Messages getMessages (Integer lastMessageNumber, Boolean last, String chatId, Integer limit, Integer minTime, Integer maxTime) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/messages";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "lastMessageNumber", lastMessageNumber));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "last", last));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "chatId", chatId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "limit", limit));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min_time", minTime));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max_time", maxTime));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (Messages) ApiInvoker.deserialize(localVarResponse, "", Messages.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Get a list of messages.
   * To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
   * @param lastMessageNumber The lastMessageNumber parameter from the last response   * @param last Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored.   * @param chatId Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group.   * @param limit Sets length of the message list. Default 100. With value 0 returns all messages.   * @param minTime Filter messages received after specified time. Example: 946684800.   * @param maxTime Filter messages received before specified time. Example: 946684800.
  */
  public void getMessages (Integer lastMessageNumber, Boolean last, String chatId, Integer limit, Integer minTime, Integer maxTime, final Response.Listener<Messages> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/messages".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "lastMessageNumber", lastMessageNumber));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "last", last));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "chatId", chatId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "limit", limit));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min_time", minTime));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max_time", maxTime));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((Messages) ApiInvoker.deserialize(localVarResponse,  "", Messages.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Sending a contact or contact list to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendContactRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendContact (SendContactRequest sendContactRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendContactRequest;
    // verify the required parameter 'sendContactRequest' is set
    if (sendContactRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendContactRequest' when calling sendContact",
        new ApiException(400, "Missing the required parameter 'sendContactRequest' when calling sendContact"));
    }

    // create path and map variables
    String path = "/sendContact";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Sending a contact or contact list to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendContactRequest 
  */
  public void sendContact (SendContactRequest sendContactRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendContactRequest;

    // verify the required parameter 'sendContactRequest' is set
    if (sendContactRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendContactRequest' when calling sendContact",
        new ApiException(400, "Missing the required parameter 'sendContactRequest' when calling sendContact"));
    }

    // create path and map variables
    String path = "/sendContact".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Send a file to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendFileRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendFile (SendFileRequest sendFileRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendFileRequest;
    // verify the required parameter 'sendFileRequest' is set
    if (sendFileRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendFileRequest' when calling sendFile",
        new ApiException(400, "Missing the required parameter 'sendFileRequest' when calling sendFile"));
    }

    // create path and map variables
    String path = "/sendFile";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Send a file to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendFileRequest 
  */
  public void sendFile (SendFileRequest sendFileRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendFileRequest;

    // verify the required parameter 'sendFileRequest' is set
    if (sendFileRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendFileRequest' when calling sendFile",
        new ApiException(400, "Missing the required parameter 'sendFileRequest' when calling sendFile"));
    }

    // create path and map variables
    String path = "/sendFile".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Send text with link and link&#39;s preview to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendLinkRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendLink (SendLinkRequest sendLinkRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendLinkRequest;
    // verify the required parameter 'sendLinkRequest' is set
    if (sendLinkRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendLinkRequest' when calling sendLink",
        new ApiException(400, "Missing the required parameter 'sendLinkRequest' when calling sendLink"));
    }

    // create path and map variables
    String path = "/sendLink";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Send text with link and link&#39;s preview to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendLinkRequest 
  */
  public void sendLink (SendLinkRequest sendLinkRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendLinkRequest;

    // verify the required parameter 'sendLinkRequest' is set
    if (sendLinkRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendLinkRequest' when calling sendLink",
        new ApiException(400, "Missing the required parameter 'sendLinkRequest' when calling sendLink"));
    }

    // create path and map variables
    String path = "/sendLink".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Sending a location to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendLocationRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendLocation (SendLocationRequest sendLocationRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendLocationRequest;
    // verify the required parameter 'sendLocationRequest' is set
    if (sendLocationRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendLocationRequest' when calling sendLocation",
        new ApiException(400, "Missing the required parameter 'sendLocationRequest' when calling sendLocation"));
    }

    // create path and map variables
    String path = "/sendLocation";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Sending a location to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendLocationRequest 
  */
  public void sendLocation (SendLocationRequest sendLocationRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendLocationRequest;

    // verify the required parameter 'sendLocationRequest' is set
    if (sendLocationRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendLocationRequest' when calling sendLocation",
        new ApiException(400, "Missing the required parameter 'sendLocationRequest' when calling sendLocation"));
    }

    // create path and map variables
    String path = "/sendLocation".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Send a message to a new or existing chat.
  * The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendMessageRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendMessage (SendMessageRequest sendMessageRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendMessageRequest;
    // verify the required parameter 'sendMessageRequest' is set
    if (sendMessageRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendMessageRequest' when calling sendMessage",
        new ApiException(400, "Missing the required parameter 'sendMessageRequest' when calling sendMessage"));
    }

    // create path and map variables
    String path = "/sendMessage";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Send a message to a new or existing chat.
   * The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendMessageRequest 
  */
  public void sendMessage (SendMessageRequest sendMessageRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendMessageRequest;

    // verify the required parameter 'sendMessageRequest' is set
    if (sendMessageRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendMessageRequest' when calling sendMessage",
        new ApiException(400, "Missing the required parameter 'sendMessageRequest' when calling sendMessage"));
    }

    // create path and map variables
    String path = "/sendMessage".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Send a ptt-audio to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendPTTRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendPTT (SendPTTRequest sendPTTRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendPTTRequest;
    // verify the required parameter 'sendPTTRequest' is set
    if (sendPTTRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendPTTRequest' when calling sendPTT",
        new ApiException(400, "Missing the required parameter 'sendPTTRequest' when calling sendPTT"));
    }

    // create path and map variables
    String path = "/sendPTT";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Send a ptt-audio to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendPTTRequest 
  */
  public void sendPTT (SendPTTRequest sendPTTRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendPTTRequest;

    // verify the required parameter 'sendPTTRequest' is set
    if (sendPTTRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendPTTRequest' when calling sendPTT",
        new ApiException(400, "Missing the required parameter 'sendPTTRequest' when calling sendPTT"));
    }

    // create path and map variables
    String path = "/sendPTT".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Sending a vcard to a new or existing chat.
  * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendVCardRequest 
   * @return SendMessageStatus
  */
  public SendMessageStatus sendVCard (SendVCardRequest sendVCardRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = sendVCardRequest;
    // verify the required parameter 'sendVCardRequest' is set
    if (sendVCardRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendVCardRequest' when calling sendVCard",
        new ApiException(400, "Missing the required parameter 'sendVCardRequest' when calling sendVCard"));
    }

    // create path and map variables
    String path = "/sendVCard";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SendMessageStatus) ApiInvoker.deserialize(localVarResponse, "", SendMessageStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Sending a vcard to a new or existing chat.
   * Only one of two parameters is needed to determine the destination - chatId or phone.
   * @param sendVCardRequest 
  */
  public void sendVCard (SendVCardRequest sendVCardRequest, final Response.Listener<SendMessageStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = sendVCardRequest;

    // verify the required parameter 'sendVCardRequest' is set
    if (sendVCardRequest == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'sendVCardRequest' when calling sendVCard",
        new ApiException(400, "Missing the required parameter 'sendVCardRequest' when calling sendVCard"));
    }

    // create path and map variables
    String path = "/sendVCard".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SendMessageStatus) ApiInvoker.deserialize(localVarResponse,  "", SendMessageStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
}
