/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.api;

import org.openapitools.client.ApiInvoker;
import org.openapitools.client.ApiException;
import org.openapitools.client.Pair;

import org.openapitools.client.model.*;

import java.util.*;

import com.android.volley.Response;
import com.android.volley.VolleyError;

import org.openapitools.client.model.Chats;
import org.openapitools.client.model.CreateGroupAction;
import org.openapitools.client.model.CreateGroupStatus;
import org.openapitools.client.model.GroupParticipantAction;
import org.openapitools.client.model.GroupParticipantStatus;
import org.openapitools.client.model.ReadChatAction;
import org.openapitools.client.model.ReadChatStatus;

import org.apache.http.HttpEntity;
import org.apache.http.entity.mime.MultipartEntityBuilder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;

public class Class3ChatsApi {
  String basePath = "https://api.chat-api.com";
  ApiInvoker apiInvoker = ApiInvoker.getInstance();

  public void addHeader(String key, String value) {
    getInvoker().addDefaultHeader(key, value);
  }

  public ApiInvoker getInvoker() {
    return apiInvoker;
  }

  public void setBasePath(String basePath) {
    this.basePath = basePath;
  }

  public String getBasePath() {
    return basePath;
  }

  /**
  * Adding participant to a group
  * 
   * @param groupParticipantAction 
   * @return GroupParticipantStatus
  */
  public GroupParticipantStatus addGroupParticipant (GroupParticipantAction groupParticipantAction) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = groupParticipantAction;
    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling addGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling addGroupParticipant"));
    }

    // create path and map variables
    String path = "/addGroupParticipant";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse, "", GroupParticipantStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Adding participant to a group
   * 
   * @param groupParticipantAction 
  */
  public void addGroupParticipant (GroupParticipantAction groupParticipantAction, final Response.Listener<GroupParticipantStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = groupParticipantAction;

    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling addGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling addGroupParticipant"));
    }

    // create path and map variables
    String path = "/addGroupParticipant".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse,  "", GroupParticipantStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Demote group participant
  * 
   * @param groupParticipantAction 
   * @return GroupParticipantStatus
  */
  public GroupParticipantStatus demoteGroupParticipant (GroupParticipantAction groupParticipantAction) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = groupParticipantAction;
    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling demoteGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling demoteGroupParticipant"));
    }

    // create path and map variables
    String path = "/demoteGroupParticipant";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse, "", GroupParticipantStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Demote group participant
   * 
   * @param groupParticipantAction 
  */
  public void demoteGroupParticipant (GroupParticipantAction groupParticipantAction, final Response.Listener<GroupParticipantStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = groupParticipantAction;

    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling demoteGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling demoteGroupParticipant"));
    }

    // create path and map variables
    String path = "/demoteGroupParticipant".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse,  "", GroupParticipantStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Get the chat list.
  * The chat list includes avatars.
   * @return Chats
  */
  public Chats getChats () throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/dialogs";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (Chats) ApiInvoker.deserialize(localVarResponse, "", Chats.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Get the chat list.
   * The chat list includes avatars.

  */
  public void getChats (final Response.Listener<Chats> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/dialogs".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((Chats) ApiInvoker.deserialize(localVarResponse,  "", Chats.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Creates a group and sends the message to the created group.
  * The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
   * @param createGroupAction 
   * @return CreateGroupStatus
  */
  public CreateGroupStatus group (CreateGroupAction createGroupAction) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = createGroupAction;
    // verify the required parameter 'createGroupAction' is set
    if (createGroupAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'createGroupAction' when calling group",
        new ApiException(400, "Missing the required parameter 'createGroupAction' when calling group"));
    }

    // create path and map variables
    String path = "/group";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (CreateGroupStatus) ApiInvoker.deserialize(localVarResponse, "", CreateGroupStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Creates a group and sends the message to the created group.
   * The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
   * @param createGroupAction 
  */
  public void group (CreateGroupAction createGroupAction, final Response.Listener<CreateGroupStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = createGroupAction;

    // verify the required parameter 'createGroupAction' is set
    if (createGroupAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'createGroupAction' when calling group",
        new ApiException(400, "Missing the required parameter 'createGroupAction' when calling group"));
    }

    // create path and map variables
    String path = "/group".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((CreateGroupStatus) ApiInvoker.deserialize(localVarResponse,  "", CreateGroupStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Make participant in the group an administrator
  * 
   * @param groupParticipantAction 
   * @return GroupParticipantStatus
  */
  public GroupParticipantStatus promoteGroupParticipant (GroupParticipantAction groupParticipantAction) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = groupParticipantAction;
    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling promoteGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling promoteGroupParticipant"));
    }

    // create path and map variables
    String path = "/promoteGroupParticipant";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse, "", GroupParticipantStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Make participant in the group an administrator
   * 
   * @param groupParticipantAction 
  */
  public void promoteGroupParticipant (GroupParticipantAction groupParticipantAction, final Response.Listener<GroupParticipantStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = groupParticipantAction;

    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling promoteGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling promoteGroupParticipant"));
    }

    // create path and map variables
    String path = "/promoteGroupParticipant".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse,  "", GroupParticipantStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Open chat for reading messages
  * Use this method to make users see their messages read.
   * @param readChatAction 
   * @return ReadChatStatus
  */
  public ReadChatStatus readChat (ReadChatAction readChatAction) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = readChatAction;
    // verify the required parameter 'readChatAction' is set
    if (readChatAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'readChatAction' when calling readChat",
        new ApiException(400, "Missing the required parameter 'readChatAction' when calling readChat"));
    }

    // create path and map variables
    String path = "/readChat";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (ReadChatStatus) ApiInvoker.deserialize(localVarResponse, "", ReadChatStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Open chat for reading messages
   * Use this method to make users see their messages read.
   * @param readChatAction 
  */
  public void readChat (ReadChatAction readChatAction, final Response.Listener<ReadChatStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = readChatAction;

    // verify the required parameter 'readChatAction' is set
    if (readChatAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'readChatAction' when calling readChat",
        new ApiException(400, "Missing the required parameter 'readChatAction' when calling readChat"));
    }

    // create path and map variables
    String path = "/readChat".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((ReadChatStatus) ApiInvoker.deserialize(localVarResponse,  "", ReadChatStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Remove participant from a group
  * 
   * @param groupParticipantAction 
   * @return GroupParticipantStatus
  */
  public GroupParticipantStatus removeGroupParticipant (GroupParticipantAction groupParticipantAction) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = groupParticipantAction;
    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling removeGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling removeGroupParticipant"));
    }

    // create path and map variables
    String path = "/removeGroupParticipant";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/x-www-form-urlencoded",
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse, "", GroupParticipantStatus.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Remove participant from a group
   * 
   * @param groupParticipantAction 
  */
  public void removeGroupParticipant (GroupParticipantAction groupParticipantAction, final Response.Listener<GroupParticipantStatus> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = groupParticipantAction;

    // verify the required parameter 'groupParticipantAction' is set
    if (groupParticipantAction == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'groupParticipantAction' when calling removeGroupParticipant",
        new ApiException(400, "Missing the required parameter 'groupParticipantAction' when calling removeGroupParticipant"));
    }

    // create path and map variables
    String path = "/removeGroupParticipant".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/x-www-form-urlencoded","application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "instanceId", "token" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((GroupParticipantStatus) ApiInvoker.deserialize(localVarResponse,  "", GroupParticipantStatus.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
}
