/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import java.util.*;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class CreateGroupAction {
  
  @SerializedName("groupName")
  private String groupName = null;
  @SerializedName("chatIds")
  private List<String> chatIds = null;
  @SerializedName("phones")
  private List<Integer> phones = null;
  @SerializedName("messageText")
  private String messageText = null;

  /**
   * Name of the group being created
   **/
  @ApiModelProperty(required = true, value = "Name of the group being created")
  public String getGroupName() {
    return groupName;
  }
  public void setGroupName(String groupName) {
    this.groupName = groupName;
  }

  /**
   * **Required if phones is not set**  An array of new participients chatIds. 
   **/
  @ApiModelProperty(value = "**Required if phones is not set**  An array of new participients chatIds. ")
  public List<String> getChatIds() {
    return chatIds;
  }
  public void setChatIds(List<String> chatIds) {
    this.chatIds = chatIds;
  }

  /**
   * **Required if chatIds is not set**  An array of phones starting with the country code. You do not need to add your number.   USA example: [17472822486'].
   **/
  @ApiModelProperty(value = "**Required if chatIds is not set**  An array of phones starting with the country code. You do not need to add your number.   USA example: [17472822486'].")
  public List<Integer> getPhones() {
    return phones;
  }
  public void setPhones(List<Integer> phones) {
    this.phones = phones;
  }

  /**
   * The text of the message that will be sent to the group when it is created. If you do not set a parameter, the message will not be sent
   **/
  @ApiModelProperty(value = "The text of the message that will be sent to the group when it is created. If you do not set a parameter, the message will not be sent")
  public String getMessageText() {
    return messageText;
  }
  public void setMessageText(String messageText) {
    this.messageText = messageText;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateGroupAction createGroupAction = (CreateGroupAction) o;
    return (this.groupName == null ? createGroupAction.groupName == null : this.groupName.equals(createGroupAction.groupName)) &&
        (this.chatIds == null ? createGroupAction.chatIds == null : this.chatIds.equals(createGroupAction.chatIds)) &&
        (this.phones == null ? createGroupAction.phones == null : this.phones.equals(createGroupAction.phones)) &&
        (this.messageText == null ? createGroupAction.messageText == null : this.messageText.equals(createGroupAction.messageText));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.groupName == null ? 0: this.groupName.hashCode());
    result = 31 * result + (this.chatIds == null ? 0: this.chatIds.hashCode());
    result = 31 * result + (this.phones == null ? 0: this.phones.hashCode());
    result = 31 * result + (this.messageText == null ? 0: this.messageText.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateGroupAction {\n");
    
    sb.append("  groupName: ").append(groupName).append("\n");
    sb.append("  chatIds: ").append(chatIds).append("\n");
    sb.append("  phones: ").append(phones).append("\n");
    sb.append("  messageText: ").append(messageText).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
