/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class ForwardMessageRequest {
  
  @SerializedName("chatId")
  private String chatId = null;
  @SerializedName("phone")
  private Integer phone = null;
  @SerializedName("messageId")
  private String messageId = null;

  /**
   * **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
   **/
  @ApiModelProperty(value = "**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.")
  public String getChatId() {
    return chatId;
  }
  public void setChatId(String chatId) {
    this.chatId = chatId;
  }

  /**
   * **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
   **/
  @ApiModelProperty(value = "**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.")
  public Integer getPhone() {
    return phone;
  }
  public void setPhone(Integer phone) {
    this.phone = phone;
  }

  /**
   * Message ID | Message IDs array. Example: \"false_6590996758@c.us_3EB03104D2B84CEAD82F\" or [\"false_6590996758@c.us_3EB03104D2B84CEAD82F\", \"false_6590996758@c.us_3EB03104D2B84CEAD82G\"]
   **/
  @ApiModelProperty(required = true, value = "Message ID | Message IDs array. Example: \"false_6590996758@c.us_3EB03104D2B84CEAD82F\" or [\"false_6590996758@c.us_3EB03104D2B84CEAD82F\", \"false_6590996758@c.us_3EB03104D2B84CEAD82G\"]")
  public String getMessageId() {
    return messageId;
  }
  public void setMessageId(String messageId) {
    this.messageId = messageId;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ForwardMessageRequest forwardMessageRequest = (ForwardMessageRequest) o;
    return (this.chatId == null ? forwardMessageRequest.chatId == null : this.chatId.equals(forwardMessageRequest.chatId)) &&
        (this.phone == null ? forwardMessageRequest.phone == null : this.phone.equals(forwardMessageRequest.phone)) &&
        (this.messageId == null ? forwardMessageRequest.messageId == null : this.messageId.equals(forwardMessageRequest.messageId));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.chatId == null ? 0: this.chatId.hashCode());
    result = 31 * result + (this.phone == null ? 0: this.phone.hashCode());
    result = 31 * result + (this.messageId == null ? 0: this.messageId.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class ForwardMessageRequest {\n");
    
    sb.append("  chatId: ").append(chatId).append("\n");
    sb.append("  phone: ").append(phone).append("\n");
    sb.append("  messageId: ").append(messageId).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
