/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class GroupParticipantAction {
  
  @SerializedName("groupId")
  private String groupId = null;
  @SerializedName("participantChatId")
  private String participantChatId = null;
  @SerializedName("participantPhone")
  private Integer participantPhone = null;

  /**
   * Chat ID from the chat list. Examples: 19680561234-1479621234@g.us for the group.
   **/
  @ApiModelProperty(required = true, value = "Chat ID from the chat list. Examples: 19680561234-1479621234@g.us for the group.")
  public String getGroupId() {
    return groupId;
  }
  public void setGroupId(String groupId) {
    this.groupId = groupId;
  }

  /**
   * **Required if participantPhone is not set**  Chat ID from the message list. Examples: 17633123456@c.us. Used instead of the participantPhone parameter.
   **/
  @ApiModelProperty(required = true, value = "**Required if participantPhone is not set**  Chat ID from the message list. Examples: 17633123456@c.us. Used instead of the participantPhone parameter.")
  public String getParticipantChatId() {
    return participantChatId;
  }
  public void setParticipantChatId(String participantChatId) {
    this.participantChatId = participantChatId;
  }

  /**
   * **Required if participantChatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
   **/
  @ApiModelProperty(value = "**Required if participantChatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.")
  public Integer getParticipantPhone() {
    return participantPhone;
  }
  public void setParticipantPhone(Integer participantPhone) {
    this.participantPhone = participantPhone;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GroupParticipantAction groupParticipantAction = (GroupParticipantAction) o;
    return (this.groupId == null ? groupParticipantAction.groupId == null : this.groupId.equals(groupParticipantAction.groupId)) &&
        (this.participantChatId == null ? groupParticipantAction.participantChatId == null : this.participantChatId.equals(groupParticipantAction.participantChatId)) &&
        (this.participantPhone == null ? groupParticipantAction.participantPhone == null : this.participantPhone.equals(groupParticipantAction.participantPhone));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.groupId == null ? 0: this.groupId.hashCode());
    result = 31 * result + (this.participantChatId == null ? 0: this.participantChatId.hashCode());
    result = 31 * result + (this.participantPhone == null ? 0: this.participantPhone.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class GroupParticipantAction {\n");
    
    sb.append("  groupId: ").append(groupId).append("\n");
    sb.append("  participantChatId: ").append(participantChatId).append("\n");
    sb.append("  participantPhone: ").append(participantPhone).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
