/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import org.openapitools.client.model.InstanceStatusStatusDataActions;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * More information about instance status
 **/
@ApiModel(description = "More information about instance status")
public class InstanceStatusStatusData {
  
  public enum SubstatusEnum {
     normal,  loading,  offline,  expired,  opening,  pairing,  timeout,  computer,  phone,  battery_low_1,  battery_low_2, 
  };
  @SerializedName("substatus")
  private SubstatusEnum substatus = null;
  @SerializedName("title")
  private String title = null;
  @SerializedName("msg")
  private String msg = null;
  @SerializedName("submsg")
  private String submsg = null;
  @SerializedName("actions")
  private InstanceStatusStatusDataActions actions = null;
  public enum ReasonEnum {
     connecting,  syncing,  offline,  proxyblock,  conflict, 
  };
  @SerializedName("reason")
  private ReasonEnum reason = null;

  /**
   * Instance Substatus
   **/
  @ApiModelProperty(value = "Instance Substatus")
  public SubstatusEnum getSubstatus() {
    return substatus;
  }
  public void setSubstatus(SubstatusEnum substatus) {
    this.substatus = substatus;
  }

  /**
   * Status title in the language of the instance
   **/
  @ApiModelProperty(value = "Status title in the language of the instance")
  public String getTitle() {
    return title;
  }
  public void setTitle(String title) {
    this.title = title;
  }

  /**
   * Status message in the language of the instance
   **/
  @ApiModelProperty(value = "Status message in the language of the instance")
  public String getMsg() {
    return msg;
  }
  public void setMsg(String msg) {
    this.msg = msg;
  }

  /**
   * Additional status message in the language of the instance
   **/
  @ApiModelProperty(value = "Additional status message in the language of the instance")
  public String getSubmsg() {
    return submsg;
  }
  public void setSubmsg(String submsg) {
    this.submsg = submsg;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public InstanceStatusStatusDataActions getActions() {
    return actions;
  }
  public void setActions(InstanceStatusStatusDataActions actions) {
    this.actions = actions;
  }

  /**
   * The reason why the instance is in \"loading\" status
   **/
  @ApiModelProperty(value = "The reason why the instance is in \"loading\" status")
  public ReasonEnum getReason() {
    return reason;
  }
  public void setReason(ReasonEnum reason) {
    this.reason = reason;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InstanceStatusStatusData instanceStatusStatusData = (InstanceStatusStatusData) o;
    return (this.substatus == null ? instanceStatusStatusData.substatus == null : this.substatus.equals(instanceStatusStatusData.substatus)) &&
        (this.title == null ? instanceStatusStatusData.title == null : this.title.equals(instanceStatusStatusData.title)) &&
        (this.msg == null ? instanceStatusStatusData.msg == null : this.msg.equals(instanceStatusStatusData.msg)) &&
        (this.submsg == null ? instanceStatusStatusData.submsg == null : this.submsg.equals(instanceStatusStatusData.submsg)) &&
        (this.actions == null ? instanceStatusStatusData.actions == null : this.actions.equals(instanceStatusStatusData.actions)) &&
        (this.reason == null ? instanceStatusStatusData.reason == null : this.reason.equals(instanceStatusStatusData.reason));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.substatus == null ? 0: this.substatus.hashCode());
    result = 31 * result + (this.title == null ? 0: this.title.hashCode());
    result = 31 * result + (this.msg == null ? 0: this.msg.hashCode());
    result = 31 * result + (this.submsg == null ? 0: this.submsg.hashCode());
    result = 31 * result + (this.actions == null ? 0: this.actions.hashCode());
    result = 31 * result + (this.reason == null ? 0: this.reason.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class InstanceStatusStatusData {\n");
    
    sb.append("  substatus: ").append(substatus).append("\n");
    sb.append("  title: ").append(title).append("\n");
    sb.append("  msg: ").append(msg).append("\n");
    sb.append("  submsg: ").append(submsg).append("\n");
    sb.append("  actions: ").append(actions).append("\n");
    sb.append("  reason: ").append(reason).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
