/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class Message {
  
  @SerializedName("id")
  private String id = null;
  @SerializedName("body")
  private String body = null;
  public enum TypeEnum {
     chat,  image,  ptt,  document,  audio,  video,  location,  call_log, 
  };
  @SerializedName("type")
  private TypeEnum type = null;
  @SerializedName("senderName")
  private String senderName = null;
  @SerializedName("fromMe")
  private Boolean fromMe = null;
  @SerializedName("author")
  private String author = null;
  @SerializedName("time")
  private Integer time = null;
  @SerializedName("chatId")
  private String chatId = null;
  @SerializedName("messageNumber")
  private Integer messageNumber = null;

  /**
   * unique id
   **/
  @ApiModelProperty(value = "unique id")
  public String getId() {
    return id;
  }
  public void setId(String id) {
    this.id = id;
  }

  /**
   * text message for type \"chat\", or link to download the file for \"ptt\", \"image\", \"audio\", \"video\" and \"document\", or latitude and longitude for \"location\", or message \"[Call]\" for \"call_log\"
   **/
  @ApiModelProperty(value = "text message for type \"chat\", or link to download the file for \"ptt\", \"image\", \"audio\", \"video\" and \"document\", or latitude and longitude for \"location\", or message \"[Call]\" for \"call_log\"")
  public String getBody() {
    return body;
  }
  public void setBody(String body) {
    this.body = body;
  }

  /**
   * type of the message
   **/
  @ApiModelProperty(value = "type of the message")
  public TypeEnum getType() {
    return type;
  }
  public void setType(TypeEnum type) {
    this.type = type;
  }

  /**
   * Sender name
   **/
  @ApiModelProperty(value = "Sender name")
  public String getSenderName() {
    return senderName;
  }
  public void setSenderName(String senderName) {
    this.senderName = senderName;
  }

  /**
   * true - outgoing, false - incoming
   **/
  @ApiModelProperty(value = "true - outgoing, false - incoming")
  public Boolean getFromMe() {
    return fromMe;
  }
  public void setFromMe(Boolean fromMe) {
    this.fromMe = fromMe;
  }

  /**
   * Author ID of the message, useful for groups
   **/
  @ApiModelProperty(value = "Author ID of the message, useful for groups")
  public String getAuthor() {
    return author;
  }
  public void setAuthor(String author) {
    this.author = author;
  }

  /**
   * send time, unix timestamp
   **/
  @ApiModelProperty(value = "send time, unix timestamp")
  public Integer getTime() {
    return time;
  }
  public void setTime(Integer time) {
    this.time = time;
  }

  /**
   * chat ID
   **/
  @ApiModelProperty(value = "chat ID")
  public String getChatId() {
    return chatId;
  }
  public void setChatId(String chatId) {
    this.chatId = chatId;
  }

  /**
   * sequence number of the message in the database
   **/
  @ApiModelProperty(value = "sequence number of the message in the database")
  public Integer getMessageNumber() {
    return messageNumber;
  }
  public void setMessageNumber(Integer messageNumber) {
    this.messageNumber = messageNumber;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Message message = (Message) o;
    return (this.id == null ? message.id == null : this.id.equals(message.id)) &&
        (this.body == null ? message.body == null : this.body.equals(message.body)) &&
        (this.type == null ? message.type == null : this.type.equals(message.type)) &&
        (this.senderName == null ? message.senderName == null : this.senderName.equals(message.senderName)) &&
        (this.fromMe == null ? message.fromMe == null : this.fromMe.equals(message.fromMe)) &&
        (this.author == null ? message.author == null : this.author.equals(message.author)) &&
        (this.time == null ? message.time == null : this.time.equals(message.time)) &&
        (this.chatId == null ? message.chatId == null : this.chatId.equals(message.chatId)) &&
        (this.messageNumber == null ? message.messageNumber == null : this.messageNumber.equals(message.messageNumber));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.body == null ? 0: this.body.hashCode());
    result = 31 * result + (this.type == null ? 0: this.type.hashCode());
    result = 31 * result + (this.senderName == null ? 0: this.senderName.hashCode());
    result = 31 * result + (this.fromMe == null ? 0: this.fromMe.hashCode());
    result = 31 * result + (this.author == null ? 0: this.author.hashCode());
    result = 31 * result + (this.time == null ? 0: this.time.hashCode());
    result = 31 * result + (this.chatId == null ? 0: this.chatId.hashCode());
    result = 31 * result + (this.messageNumber == null ? 0: this.messageNumber.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class Message {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  body: ").append(body).append("\n");
    sb.append("  type: ").append(type).append("\n");
    sb.append("  senderName: ").append(senderName).append("\n");
    sb.append("  fromMe: ").append(fromMe).append("\n");
    sb.append("  author: ").append(author).append("\n");
    sb.append("  time: ").append(time).append("\n");
    sb.append("  chatId: ").append(chatId).append("\n");
    sb.append("  messageNumber: ").append(messageNumber).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
