/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class OutboundMessage {
  
  @SerializedName("id")
  private Integer id = null;
  @SerializedName("body")
  private String body = null;
  public enum TypeEnum {
     chat,  image,  ptt,  document,  audio,  video,  location,  call_log, 
  };
  @SerializedName("type")
  private TypeEnum type = null;
  @SerializedName("last_try")
  private Integer lastTry = null;
  @SerializedName("metadata")
  private Object metadata = null;

  /**
   * message id in queue
   **/
  @ApiModelProperty(value = "message id in queue")
  public Integer getId() {
    return id;
  }
  public void setId(Integer id) {
    this.id = id;
  }

  /**
   * text message in queue
   **/
  @ApiModelProperty(value = "text message in queue")
  public String getBody() {
    return body;
  }
  public void setBody(String body) {
    this.body = body;
  }

  /**
   * type of the message in queue
   **/
  @ApiModelProperty(value = "type of the message in queue")
  public TypeEnum getType() {
    return type;
  }
  public void setType(TypeEnum type) {
    this.type = type;
  }

  /**
   * Last try time to send a message
   **/
  @ApiModelProperty(value = "Last try time to send a message")
  public Integer getLastTry() {
    return lastTry;
  }
  public void setLastTry(Integer lastTry) {
    this.lastTry = lastTry;
  }

  /**
   * Additional message data
   **/
  @ApiModelProperty(value = "Additional message data")
  public Object getMetadata() {
    return metadata;
  }
  public void setMetadata(Object metadata) {
    this.metadata = metadata;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OutboundMessage outboundMessage = (OutboundMessage) o;
    return (this.id == null ? outboundMessage.id == null : this.id.equals(outboundMessage.id)) &&
        (this.body == null ? outboundMessage.body == null : this.body.equals(outboundMessage.body)) &&
        (this.type == null ? outboundMessage.type == null : this.type.equals(outboundMessage.type)) &&
        (this.lastTry == null ? outboundMessage.lastTry == null : this.lastTry.equals(outboundMessage.lastTry)) &&
        (this.metadata == null ? outboundMessage.metadata == null : this.metadata.equals(outboundMessage.metadata));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.body == null ? 0: this.body.hashCode());
    result = 31 * result + (this.type == null ? 0: this.type.hashCode());
    result = 31 * result + (this.lastTry == null ? 0: this.lastTry.hashCode());
    result = 31 * result + (this.metadata == null ? 0: this.metadata.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class OutboundMessage {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  body: ").append(body).append("\n");
    sb.append("  type: ").append(type).append("\n");
    sb.append("  lastTry: ").append(lastTry).append("\n");
    sb.append("  metadata: ").append(metadata).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
