/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class SendContactRequest {
  
  @SerializedName("chatId")
  private String chatId = null;
  @SerializedName("phone")
  private Integer phone = null;
  @SerializedName("contactId")
  private String contactId = null;

  /**
   * **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
   **/
  @ApiModelProperty(value = "**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.")
  public String getChatId() {
    return chatId;
  }
  public void setChatId(String chatId) {
    this.chatId = chatId;
  }

  /**
   * **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
   **/
  @ApiModelProperty(value = "**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.")
  public Integer getPhone() {
    return phone;
  }
  public void setPhone(Integer phone) {
    this.phone = phone;
  }

  /**
   * Contact ID | Contact IDs array. Example: \"17633123456@c.us\" or [\"17633123456@c.us\", \"17633123457@c.us\"]
   **/
  @ApiModelProperty(required = true, value = "Contact ID | Contact IDs array. Example: \"17633123456@c.us\" or [\"17633123456@c.us\", \"17633123457@c.us\"]")
  public String getContactId() {
    return contactId;
  }
  public void setContactId(String contactId) {
    this.contactId = contactId;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SendContactRequest sendContactRequest = (SendContactRequest) o;
    return (this.chatId == null ? sendContactRequest.chatId == null : this.chatId.equals(sendContactRequest.chatId)) &&
        (this.phone == null ? sendContactRequest.phone == null : this.phone.equals(sendContactRequest.phone)) &&
        (this.contactId == null ? sendContactRequest.contactId == null : this.contactId.equals(sendContactRequest.contactId));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.chatId == null ? 0: this.chatId.hashCode());
    result = 31 * result + (this.phone == null ? 0: this.phone.hashCode());
    result = 31 * result + (this.contactId == null ? 0: this.contactId.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class SendContactRequest {\n");
    
    sb.append("  chatId: ").append(chatId).append("\n");
    sb.append("  phone: ").append(phone).append("\n");
    sb.append("  contactId: ").append(contactId).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
