/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class SendLinkRequest {
  
  @SerializedName("chatId")
  private String chatId = null;
  @SerializedName("phone")
  private Integer phone = null;
  @SerializedName("body")
  private String body = null;
  @SerializedName("previewBase64")
  private String previewBase64 = null;
  @SerializedName("title")
  private String title = null;
  @SerializedName("description")
  private String description = null;

  /**
   * **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
   **/
  @ApiModelProperty(value = "**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.")
  public String getChatId() {
    return chatId;
  }
  public void setChatId(String chatId) {
    this.chatId = chatId;
  }

  /**
   * **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
   **/
  @ApiModelProperty(value = "**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.")
  public Integer getPhone() {
    return phone;
  }
  public void setPhone(Integer phone) {
    this.phone = phone;
  }

  /**
   * HTTP or HTTPS link, for example *https://wikimedia.org*
   **/
  @ApiModelProperty(required = true, value = "HTTP or HTTPS link, for example *https://wikimedia.org*")
  public String getBody() {
    return body;
  }
  public void setBody(String body) {
    this.body = body;
  }

  /**
   * Base64-encoded file with mime data, for example *data:image/jpeg;base64,/9j/4AAQSkZJRgABAQ...* for link's preview
   **/
  @ApiModelProperty(required = true, value = "Base64-encoded file with mime data, for example *data:image/jpeg;base64,/9j/4AAQSkZJRgABAQ...* for link's preview")
  public String getPreviewBase64() {
    return previewBase64;
  }
  public void setPreviewBase64(String previewBase64) {
    this.previewBase64 = previewBase64;
  }

  /**
   * Title for send link
   **/
  @ApiModelProperty(required = true, value = "Title for send link")
  public String getTitle() {
    return title;
  }
  public void setTitle(String title) {
    this.title = title;
  }

  /**
   * Description for send link
   **/
  @ApiModelProperty(value = "Description for send link")
  public String getDescription() {
    return description;
  }
  public void setDescription(String description) {
    this.description = description;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SendLinkRequest sendLinkRequest = (SendLinkRequest) o;
    return (this.chatId == null ? sendLinkRequest.chatId == null : this.chatId.equals(sendLinkRequest.chatId)) &&
        (this.phone == null ? sendLinkRequest.phone == null : this.phone.equals(sendLinkRequest.phone)) &&
        (this.body == null ? sendLinkRequest.body == null : this.body.equals(sendLinkRequest.body)) &&
        (this.previewBase64 == null ? sendLinkRequest.previewBase64 == null : this.previewBase64.equals(sendLinkRequest.previewBase64)) &&
        (this.title == null ? sendLinkRequest.title == null : this.title.equals(sendLinkRequest.title)) &&
        (this.description == null ? sendLinkRequest.description == null : this.description.equals(sendLinkRequest.description));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.chatId == null ? 0: this.chatId.hashCode());
    result = 31 * result + (this.phone == null ? 0: this.phone.hashCode());
    result = 31 * result + (this.body == null ? 0: this.body.hashCode());
    result = 31 * result + (this.previewBase64 == null ? 0: this.previewBase64.hashCode());
    result = 31 * result + (this.title == null ? 0: this.title.hashCode());
    result = 31 * result + (this.description == null ? 0: this.description.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class SendLinkRequest {\n");
    
    sb.append("  chatId: ").append(chatId).append("\n");
    sb.append("  phone: ").append(phone).append("\n");
    sb.append("  body: ").append(body).append("\n");
    sb.append("  previewBase64: ").append(previewBase64).append("\n");
    sb.append("  title: ").append(title).append("\n");
    sb.append("  description: ").append(description).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
