/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package org.openapitools.client.model;

import java.math.BigDecimal;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class SendLocationRequest {
  
  @SerializedName("chatId")
  private String chatId = null;
  @SerializedName("phone")
  private Integer phone = null;
  @SerializedName("lat")
  private BigDecimal lat = null;
  @SerializedName("lng")
  private BigDecimal lng = null;
  @SerializedName("address")
  private String address = null;

  /**
   * **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
   **/
  @ApiModelProperty(value = "**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.")
  public String getChatId() {
    return chatId;
  }
  public void setChatId(String chatId) {
    this.chatId = chatId;
  }

  /**
   * **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
   **/
  @ApiModelProperty(value = "**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.")
  public Integer getPhone() {
    return phone;
  }
  public void setPhone(Integer phone) {
    this.phone = phone;
  }

  /**
   * Latitude
   **/
  @ApiModelProperty(required = true, value = "Latitude")
  public BigDecimal getLat() {
    return lat;
  }
  public void setLat(BigDecimal lat) {
    this.lat = lat;
  }

  /**
   * Longitude
   **/
  @ApiModelProperty(required = true, value = "Longitude")
  public BigDecimal getLng() {
    return lng;
  }
  public void setLng(BigDecimal lng) {
    this.lng = lng;
  }

  /**
   * Text under the location.  Supports two lines. To use two lines, use the \"\\n\" symbol.
   **/
  @ApiModelProperty(required = true, value = "Text under the location.  Supports two lines. To use two lines, use the \"\\n\" symbol.")
  public String getAddress() {
    return address;
  }
  public void setAddress(String address) {
    this.address = address;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SendLocationRequest sendLocationRequest = (SendLocationRequest) o;
    return (this.chatId == null ? sendLocationRequest.chatId == null : this.chatId.equals(sendLocationRequest.chatId)) &&
        (this.phone == null ? sendLocationRequest.phone == null : this.phone.equals(sendLocationRequest.phone)) &&
        (this.lat == null ? sendLocationRequest.lat == null : this.lat.equals(sendLocationRequest.lat)) &&
        (this.lng == null ? sendLocationRequest.lng == null : this.lng.equals(sendLocationRequest.lng)) &&
        (this.address == null ? sendLocationRequest.address == null : this.address.equals(sendLocationRequest.address));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.chatId == null ? 0: this.chatId.hashCode());
    result = 31 * result + (this.phone == null ? 0: this.phone.hashCode());
    result = 31 * result + (this.lat == null ? 0: this.lat.hashCode());
    result = 31 * result + (this.lng == null ? 0: this.lng.hashCode());
    result = 31 * result + (this.address == null ? 0: this.address.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class SendLocationRequest {\n");
    
    sb.append("  chatId: ").append(chatId).append("\n");
    sb.append("  phone: ").append(phone).append("\n");
    sb.append("  lat: ").append(lat).append("\n");
    sb.append("  lng: ").append(lng).append("\n");
    sb.append("  address: ").append(address).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
